      SUBROUTINE SIMBOL (XPAGE,YPAGE,HEIGH ,STRING,ANGLE,NCH)
C ***
C **********************************************************************
C ***************** SYMBOL *********************************************
C **********************************************************************
C *** PARAMETER:
C ***     XPAGE,YPAGE:  INPUT, STARTKOORDINATEN IN CM
C ***     HEIGHT:       INPUT, GROESSE DER SYMBOLE IN CM
C ***     STRING:       INPUT, TYP CHARACTER, ZEICHENKETTE
C ***     ANGLE:        INPUT, WINKEL DES SCHRIFTZUGES IN WINKELGRAD
C ***     NCH:          INPUT, ANZAHL DER AUSZUGEBENDE ZEICHEN
C ***
C ***
C **********************************************************************
C ***             DECLARATIONS
C **********************************************************************
c     DIMENSION RVFELD(NRV), IVFELD(NIV)
      DIMENSION RVFELD(*), IVFELD(*)
      COMMON    /ENDPTS/ XPNEU,YPNEU,LGKS ! NEUE STARTPOSITION
C     COMMON    /TEKTRO/ IOK,VFT,LREC,HXA,HYA,LYA,LASTX,LASTY,NOUT,
C    *          IPENA,LPX,LPY,LRANGE,NEWLIN,IDEV,IPAPER,IROT,IERR
C ***
      LOGICAL   LGKS,LTEXTL ! .FALSE.-> UMSCHALTZEICHEN
      INTEGER   INDEX(0:126),CHALEN(0:126),KX(920),KY(920)
      INTEGER   LEN,I,PEN,PENS,ICODE
      INTEGER   IPOINT,ZENS,ZENSA,NCH,NCHAR
      LOGICAL   ZEN
      CHARACTER STRING*(*)
      INTEGER   KX0(94),KVRLX1(91),KVRLX2(78),KVRLX3(97),
     1KVRLX4(86),KVRLX5(90),KVRLX6(70),KVRLX7(11)
      INTEGER   KY0(94),KVRLY1(91),KVRLY2(78),KVRLY3(97),
     1KVRLY4(86),KVRLY5(90),KVRLY6(70),KVRLY7(11)
      REAL      RSTX,RSTY,LPX,LPY
      REAL      X0,Y0,XW,YW,XH,YH
      REAL      HVX,HVY
      COMMON/QPLOTQ/IFLEC,DUM(51),LDASYM
      EQUIVALENCE (KX(1) ,KX0(1))
      EQUIVALENCE (KX(95),KVRLX1(1))
      EQUIVALENCE (KX(186),KVRLX2(1))
      EQUIVALENCE (KX(264),KVRLX3(1))
      EQUIVALENCE (KX(361),KVRLX4(1))
      EQUIVALENCE (KX(447),KVRLX5(1))
      EQUIVALENCE (KX(537),KVRLX6(1))
      EQUIVALENCE (KX(607),KVRLX7(1))
      EQUIVALENCE (KY(1),KY0(1))
      EQUIVALENCE (KY(95),KVRLY1(1))
      EQUIVALENCE (KY(186),KVRLY2(1))
      EQUIVALENCE (KY(264),KVRLY3(1))
      EQUIVALENCE (KY(361),KVRLY4(1))
      EQUIVALENCE (KY(447),KVRLY5(1))
      EQUIVALENCE (KY(537),KVRLY6(1))
      EQUIVALENCE (KY(607),KVRLY7(1))
C
C *** DATA STRUCTURE FOR SOFTWARE CHARACTERS:
C ***       INDEX(I)  = STARTPOSITION OF DATA IN KX,KY
C ***       CHALEN( I) = LENGTH OF DATA IN KX,KY
      DATA INDEX(  0),CHALEN(  0)/618, 7/     ! 0
      DATA INDEX(  1),CHALEN(  1)/625,11/     ! 1
      DATA INDEX(  2),CHALEN(  2)/636, 5/     ! 2
      DATA INDEX(  3),CHALEN(  3)/641, 6/     ! 3
      DATA INDEX(  4),CHALEN(  4)/647, 6/     ! 4
      DATA INDEX(  5),CHALEN(  5)/653, 6/     ! 5
      DATA INDEX(  6),CHALEN(  6)/659, 7/     ! 6
      DATA INDEX(  7),CHALEN(  7)/666, 7/     ! 7
      DATA INDEX(  8),CHALEN(  8)/673, 7/     ! 8
      DATA INDEX(  9),CHALEN(  9)/680, 6/     ! 9
      DATA INDEX( 10),CHALEN( 10)/686,13/     ! 10
      DATA INDEX( 11),CHALEN( 11)/699,12/     ! 11
      DATA INDEX( 12),CHALEN( 12)/711, 5/     ! 12
      DATA INDEX( 13),CHALEN( 13)/716, 3/     ! 13
      DATA INDEX( 14),CHALEN( 14)/719,10/     ! 14
      DATA INDEX( 33),CHALEN( 33)/729, 8/     ! !
      DATA INDEX( 34),CHALEN( 34)/737,10/     ! "
      DATA INDEX( 35),CHALEN( 35)/747,12/     ! #
      DATA INDEX( 36),CHALEN( 36)/759,14/     ! $
      DATA INDEX( 37),CHALEN( 37)/773,15/     ! %
      DATA INDEX( 38),CHALEN( 38)/788,12/     ! &
      DATA INDEX( 39),CHALEN( 39)/800, 5/     ! '
      DATA INDEX( 58),CHALEN( 58)/805,10/     ! :
      DATA INDEX( 59),CHALEN( 59)/815,12/     ! ;
      DATA INDEX( 60),CHALEN( 60)/827, 4/     ! <
      DATA INDEX( 62),CHALEN( 62)/831, 4/     ! >
      DATA INDEX( 63),CHALEN( 63)/835,15/     ! ?
      DATA INDEX( 64),CHALEN( 64)/850,17/     ! @
      DATA INDEX( 91),CHALEN( 91)/867, 5/     ! [
      DATA INDEX( 92),CHALEN( 92)/872, 3/     ! \
      DATA INDEX( 93),CHALEN( 93)/875, 5/     ! ]
      DATA INDEX( 94),CHALEN( 94)/880, 4/     ! ^
      DATA INDEX( 95),CHALEN( 95)/884, 1/     ! _
      DATA INDEX( 96),CHALEN( 96)/885, 5/     ! `
      DATA INDEX(123),CHALEN(123)/890,10/     ! ?
      DATA INDEX(124),CHALEN(124)/900, 6/     !
      DATA INDEX(125),CHALEN(125)/906,10/     ! !
      DATA INDEX(126),CHALEN(126)/916, 5/     ! ^
      DATA INDEX( 65),CHALEN( 65)/  1,10/     ! A GROSSBUCHSTABEN
      DATA INDEX( 66),CHALEN( 66)/ 11,14/     ! B
      DATA INDEX( 67),CHALEN( 67)/ 25,13/     ! C
      DATA INDEX( 68),CHALEN( 68)/ 38, 8/     ! D
      DATA INDEX( 69),CHALEN( 69)/ 46, 8/     ! E
      DATA INDEX( 70),CHALEN( 70)/ 54, 7/     ! F
      DATA INDEX( 71),CHALEN( 71)/ 61,15/     ! G
      DATA INDEX( 72),CHALEN( 72)/ 76, 9/     ! H
      DATA INDEX( 73),CHALEN( 73)/ 85, 3/     ! I
      DATA INDEX( 74),CHALEN( 74)/ 88, 7/     ! J
      DATA INDEX( 75),CHALEN( 75)/ 95, 9/     ! K
      DATA INDEX( 76),CHALEN( 76)/104, 4/     ! L
      DATA INDEX( 77),CHALEN( 77)/108, 4/     ! M
      DATA INDEX( 78),CHALEN( 78)/112, 3/     ! N
      DATA INDEX( 79),CHALEN( 79)/115,14/     ! O
      DATA INDEX( 80),CHALEN( 80)/129, 8/     ! P
      DATA INDEX( 81),CHALEN( 81)/137,17/     ! Q
      DATA INDEX( 82),CHALEN( 82)/154,11/     ! R
      DATA INDEX( 83),CHALEN( 83)/165,15/     ! S
      DATA INDEX( 84),CHALEN( 84)/180, 6/     ! T
      DATA INDEX( 85),CHALEN( 85)/186, 9/     ! U
      DATA INDEX( 86),CHALEN( 86)/195, 4/     ! V
      DATA INDEX( 87),CHALEN( 87)/199, 6/     ! W
      DATA INDEX( 88),CHALEN( 88)/205, 4/     ! X
      DATA INDEX( 89),CHALEN( 89)/209, 7/     ! Y
      DATA INDEX( 90),CHALEN( 90)/216, 5/     ! Z
      DATA INDEX( 97),CHALEN( 97)/221,12/     ! A KLEINBUCHSTABEN
      DATA INDEX( 98),CHALEN( 98)/233,10/     ! B
      DATA INDEX( 99),CHALEN( 99)/243, 9/     ! C
      DATA INDEX(100),CHALEN(100)/252,12/     ! D
      DATA INDEX(101),CHALEN(101)/264,11/     ! E
      DATA INDEX(102),CHALEN(102)/275, 9/     ! F
      DATA INDEX(103),CHALEN(103)/284,15/     ! G
      DATA INDEX(104),CHALEN(104)/299, 9/     ! H
      DATA INDEX(105),CHALEN(105)/308, 9/     ! I
      DATA INDEX(106),CHALEN(106)/317, 9/     ! J
      DATA INDEX(107),CHALEN(107)/326, 7/     ! K
      DATA INDEX(108),CHALEN(108)/333, 6/     ! L
      DATA INDEX(109),CHALEN(109)/339,13/     ! M
      DATA INDEX(110),CHALEN(110)/352, 9/     ! N
      DATA INDEX(111),CHALEN(111)/361,10/     ! O
      DATA INDEX(112),CHALEN(112)/371,12/     ! P
      DATA INDEX(113),CHALEN(113)/383,12/     ! Q
      DATA INDEX(114),CHALEN(114)/395, 8/     ! R
      DATA INDEX(115),CHALEN(115)/403,12/     ! S
      DATA INDEX(116),CHALEN(116)/415, 9/     ! T
      DATA INDEX(117),CHALEN(117)/424, 9/     ! U
      DATA INDEX(118),CHALEN(118)/433, 4/     ! V
      DATA INDEX(119),CHALEN(119)/437, 6/     ! W
      DATA INDEX(120),CHALEN(120)/443, 4/     ! X
      DATA INDEX(121),CHALEN(121)/447,12/     ! Y
      DATA INDEX(122),CHALEN(122)/459, 5/     ! Z
      DATA INDEX(48), CHALEN(48) /465,10/     ! 0 (NULL)
      DATA INDEX( 49),CHALEN( 49)/475, 4/     ! 1
      DATA INDEX( 50),CHALEN( 50)/479, 9/     ! 2
      DATA INDEX( 51),CHALEN( 51)/488,15/     ! 3
      DATA INDEX( 52),CHALEN( 52)/503, 7/     ! 4
      DATA INDEX( 53),CHALEN( 53)/510, 9/     ! 5
      DATA INDEX( 54),CHALEN( 54)/519,13/     ! 6
      DATA INDEX( 55),CHALEN( 55)/532, 5/     ! 7
      DATA INDEX( 56),CHALEN( 56)/537,19/     ! 8
      DATA INDEX( 57),CHALEN( 57)/556,13/     ! 9
      DATA INDEX( 43),CHALEN( 43)/569, 6/     ! +
      DATA INDEX( 45),CHALEN( 45)/575, 3/     ! -
      DATA INDEX( 42),CHALEN( 42)/578,12/     ! *
      DATA INDEX( 47),CHALEN( 47)/590, 1/     ! /
      DATA INDEX( 40),CHALEN( 40)/591, 5/     ! (
      DATA INDEX( 41),CHALEN( 41)/596, 5/     ! )
      DATA INDEX( 61),CHALEN( 61)/601, 6/     ! =
      DATA INDEX( 32),CHALEN( 32)/  0, 0/     !  BLANK
      DATA INDEX( 44),CHALEN( 44)/607, 7/     ! ,
      DATA INDEX( 46),CHALEN( 46)/614, 4/     ! .
C *** POLYLINE DEFINITIONS FOR CHARACTERS.
C *** KX,KY DEFINE THE LINES IN A 7*9 RASTER.
C *** SMALL CHARACTERS ARE REPRESENTED IN A 7*13 RASTER.
C *** KX =99 MEANS START OF A NEW POLYLINE.
C *** KVRLXN,KVRLYN (N=1,...,7) ARE CONTINUATIONS OF KX,KY.
      DATA KX0/99,1,1,2,5,6,6,99,1,6,
     199,1,1,4,6,6,4,6,6,4,1,99,1,4,
     299,6,5,4,2,1,0,0,1,2,4,5,6,
     30,3,5,6,6,5,3,0,
     499,6,1,1,6,99,1,4,
     599,6,1,1,99,1,4,
     699,6,5,4,2,1,0,0,1,2,4,5,6,6,3,
     799,1,1,99,6,6,99,1,6,
     899,3,3,
     999,1,5,5,4,2,1/
      DATA KVRLX1/99,1,1,99,6,2,99,1,6,
     199,1,1,5,
     20,3,6,6,
     30,6,6,
     499,6,5,4,2,1,0,0,1,2,4,5,6,6,
     599,1,1,4,6,6,4,1,
     699,6,5,4,2,1,0,0,1,2,4,5,6,6,99,4,6,
     799,1,1,4,6,6,4,1,99,4,6,
     899,0,0,1,5,6,6,5,1,0,0,1,5,6,6,
     999,3,3,99,0,6/
C *** LOWER CASE CHARACTERS BEGIN IN CONTINUATION LINE 6
      DATA KVRLX2/99,0,0,1,2,4,5,6,6,
     199,0,3,6,
     299,0,2,3,4,6,
     36,99,0,6,
     499,0,3,3,99,3,6,
     599,0,6,0,6,
     699,5,4,1,0,0,1,4,5,99,5,5,
     799,0,0,1,4,5,5,4,1,0,
     899,5,4,1,0,0,1,4,5,
     999,5,4,1,0,0,1,4,5,99,5,5/
      DATA KVRLX3/99,0,5,5,4,1,0,0,1,4,5,
     199,5,4,2,1,1,99,0,2,
     299,5,4,1,0,0,1,4,5,99,5,5,4,1,0,
     399,1,1,99,1,2,4,5,5,
     499,1,1,99,1,1,2,4,5,
     599,4,4,99,4,4,3,1,0,
     60,99,0,5,99,2,5,
     7 99,0,0,1,2,3,
     80,99,0,1,2,3,4,5,6,6,99,3,3,
     999,1,1,99,1,2,4,5,5/
      DATA KVRLX4/99,5,4,1,0,0,1,4,5,5,
     199,0,1,4,5,5,4,1,0,99,0,0,
     299,5,4,1,0,0,1,4,5,99,5,5,
     399,1,1,99,1,2,4,5,
     499,4,3,1,0,1,3,4,4,3,1,0,
     599,1,1,2,4,5,99,0,2,
     699,0,0,1,4,5,99,5,5,
     799,1,3,5,
     899,0,1,3,5,6,
     95,99,0,5/
C *** NUMBERS AND SPECIAL CHARACTERS START IN CONTINUATION LINE 2
      DATA KVRLX5/99,0,0,1,4,5,99,5,5,4,1,0,
     199,0,5,0,5,
     26,99,4,6,6,4,2,0,0,2,4,
     399,0,5,5,
     499,0,2,4,6,6,0,0,6,
     599,0,2,4,6,6,5,3,99,5,6,6,4,2,0,
     699,1,0,5,99,3,3,
     799,6,0,0,4,6,6,5,0,
     899,6,4,2,0,0,2,4,6,6,4,2,0,
     95,0,99,1,4/
      DATA KVRLX6/99,2,4,6,6,5,6,6,4,2,0,0,1,0,0,2,99,1,5,
     199,0,2,4,6,6,4,2,0,0,2,4,6,
     299,0,6,99,3,3,
     399,0,6,
     499,0,6,99,3,3,99,0,6,99,0,6,
     56,
     699,5,3,3,5,                            !  BETR. (   HENKE
     799,1,3,3,1,                            !  BETR. )   HENKE
     899,0,6,99,6,0/
      DATA KVRLX7/99,1,0,0,1,1,0,
     11,1,0,0/
      DATA KY0/0,0,7,9,9,7,0,0,5,5,
     10,0,9,9,8,6,5,4,1,0,0,0,5,5,
     20,6,8,9,9,8,6,3,1,0,0,1,3,
     39,9,8,6,3,1,0,0,
     40,9,9,0,0,0,5,5,
     50,9,9,0,0,5,5,
     60,6,8,9,9,8,6,3,1,0,0,1,3,4,4,
     70,9,0,0,9,0,0,5,5,
     80,9,0,
     90,9,9,1,0,0,1/
      DATA KVRLY1/0,9,0,0,0,5,0,4,9,
     10,9,0,0,
     29,4,9,0,
     39,0,9,
     40,6,8,9,9,8,6,3,1,0,0,1,3,6,
     50,0,9,9,8,6,5,5,
     60,6,8,9,9,8,6,3,1,0,0,1,3,6,0,2,0,
     70,0,9,9,8,6,5,5,0,5,0,
     80,3,1,0,0,1,3,4,5,6,8,9,9,8,6,
     90,9,0,0,9,9/
C *** LOWER CASE CHARACTERS START IN CONTINUATION LINE 6
      DATA KVRLY2/0,9,3,1,0,0,1,3,9,
     10,9,0,9,
     20,9,0,4,0,9,
     39,0,9,0,
     40,9,5,0,0,5,9,
     50,9,9,0,0,
     60,1,0,0,1,4,5,5,4,0,5,0,
     70,9,1,0,0,1,4,5,5,4,
     80,1,0,0,1,4,5,5,4,
     90,1,0,0,1,4,5,5,4,0,9,0/
      DATA KVRLY3/0,3,3,4,5,5,4,1,0,0,1,
     10,8,9,9,8,0,0,5,5,
     20,1,0,0,1,4,5,5,4,0,5,-3,-4,-4,-3,
     30,9,0,0,4,5,5,4,0,
     40,9,8,0,5,1,0,0,1,                        ! BETR. i  PUNKT HOEHER
     50,9,8,0,5,-3,-4,-4,-3,                    ! BETR. j  PUNKT HOEHER
     69,0,3,5,0,4,0,
     70,9,1,0,0,1,
     85,0,4,5,5,4,5,5,4,0,0,0,4,
     90,0,5,0,4,5,5,4,0/
      DATA KVRLY4/0,1,0,0,1,4,5,5,4,1,
     10,4,5,5,4,1,0,0,1,0,5,-4,
     20,1,0,0,1,4,5,5,4,0,5,-4,
     30,0,5,0,4,5,5,4,
     40,4,5,5,4,3,3,2,1,0,0,1,
     50,9,1,0,0,1,0,5,5,
     60,5,1,0,0,1,0,0,5,
     70,5,0,5,
     80,5,0,3,0,5,
     95,0,5,0/
C *** NUMBERS AND SPECIAL CHARACTERS START IN CONTINUATION LINE 2
      DATA KVRLY5/0,5,1,0,0,1,0,5,-3,-4,-4,-3,
     10,5,5,0,0,
     29,0,9,7,2,0,0,2,7,9,9,
     30,5,9,0,
     40,7,9,9,7,6,2,0,0,
     50,7,9,9,7,6,5,5,0,5,4,2,0,0,2,
     60,9,4,4,0,7,0,
     70,9,9,5,5,3,1,0,0,
     80,7,9,9,7,2,0,0,2,3,5,5,3,
     99,9,0,5,5/
      DATA KVRLY6/0,0,0,2,4,5,6,7,9,9,7,6,5,4,2,0,0,5,5,
     10,2,0,0,2,7,9,9,7,6,4,4,6,
     20,4,4,0,7,1,
     30,4,4,
     40,4,4,0,7,1,0,1,7,0,7,1,
     59,
     60,0,3,6,9,                          ! BETR. (   HENKE
     70,0,3,6,9,                          ! BETR. )   HENKE
     80,3,3,0,5,5/
      DATA KVRLY7/0,0,0,1,1,-1,-2,
     10,1,1,0/
C
      DATA (KX(I),I=618,672)/
     &     0,-4,-4,4,4,0,0,                  ! 0
     &     0,-2,-4,-4,-2,2,4,4,2,0,0,        ! 1
     &     0,-4,4,0,0,                       ! 2
     &     0,0,0,-4,4,0,                     ! 3
     &     4,-4,0,-4,4,0,                    ! 4
     &     0,-4,0,4,0,0,                     ! 5
     &     4,0,-4,0,0,0,0,                   ! 6
     &     4,-4,0,4,0,-4,0/                  ! 7
      DATA (KX(I),I=673,728)/
     &     4,-4,4,-4,4,-4,0,                 ! 8
     &     4,0,-4,0,0,0,                     ! 9
     &     4,2,-2,-4,-2,-2,-4,-2,2,4,2,2,0,  ! 10
     &     0,0,0,-4,4,0,4,-4,0,-4,4,0,       ! 11
     &     4,-4,4,-4,0,                      ! 12
     &     0,0,0,                            ! 13
     &     0,-4,0,4,0,0,-4,4,0,0/            ! 14
      DATA (KY(I),I=618,672)/
     &     4,4,-4,-4,4,4,0,                  ! 0
     &     4,4,2,-2,-4,-4,-2,2,4,4,0,        ! 1
     &     4,-2,-2,4,0,                      ! 2
     &     4,-4,0,0,0,0,                     ! 3
     &     4,-4,0,4,-4,0,                    ! 4
     &     4,0,-4,0,4,0,                     ! 5
     &     0,4,0,0,4,-4,0,                   ! 6
     &     4,4,0,-4,0,-4,0/                  ! 7
      DATA (KY(I),I=673,728)/
     &     4,4,4,-4,-4,-4,0,                 ! 8
     &     4,0,4,0,-4,0,                     ! 9
     &     4,2,2,4,2,-2,-4,-2,-2,-4,-2,2,0,  ! 10
     &     4,-4,0,0,0,0,4,-4,0,4,-4,0,       ! 11
     &     4,4,-4,-4,0,                      ! 12
     &     4,-4,0,                           ! 13
     &     2,2,-4,2,2,4,-2,-2,4,0/           ! 14
C
      DATA (KX(I),I=729,849)/
     &     99,4,4,99,4,3,5,4,                ! !
     &     99,2,3,3,2,99,4,5,5,4,            ! "
     &     99,1,7,99,7,1,99,3,3,99,5,5,      ! #
     &     99,1,2,6,7,7,1,1,2,6,7,99,4,4,    ! $
     &     99,1,7,99,3,1,1,3,3,99,5,7,7,5,5, ! %
     &     99,7,2,2,4,6,6,1,1,2,6,7,         ! &
     &     99,4,3,4,4,                       ! '
     &     1,1,0,0,99,0,1,1,0,0,             ! :
     &     1,0,0,1,1,0,99,0,1,1,0,0,         ! ;
     &     99,7,1,7,                         ! <
     &     99,1,7,1,                         ! >
     &     99,1,1,2,6,7,7,6,4,4,99,4,3,5,4/  ! ?
      DATA (KX(I),I=850,920)/
     &     99,5,5,4,3,3,4,5,6,7,7,6,2,1,1,2,8, ! @
     &     99,6,2,2,6,                       ! [
     &     99,1,7,                           ! \
     &     99,2,6,6,2,                       ! ]
     &     99,1,4,7,                         ! ^
     &     8,                                ! _
     &     99,5,4,3,5,                       ! `
     &     99,6,5,4,4,3,4,4,5,6,             ! {
     &     99,4,4,99,4,4,                    !
     &     99,2,3,4,4,5,4,4,3,2,             ! }
     &     99,1,2,6,7/
      DATA (KY(I),I=729,849)/
     &     0,9,2,0,1,0,0,1,                  ! !
     &     0,9,9,7,9,0,9,9,7,9,              ! "
     &     0,3,3,0,5,5,0,7,1,0,1,7,          ! #
     &     0,2,1,1,2,4,5,7,8,8,7,0,9,0,      ! $
     &     0,0,9,0,8,8,6,6,8,0,3,3,1,1,3,    ! %
     &     0,0,6,8,9,8,6,2,1,0,0,2,          ! &
     &     0,7,9,9,7,                        ! '
     &     0,1,1,0,0,3,3,4,4,3,              ! :
     &     0,0,1,1,-1,-2,0,3,3,4,4,3,        ! ;
     &     0,7,4,1,                          ! <
     &     0,1,4,7,                          ! >
     &     0,7,8,9,9,8,6,5,5,3,0,1,0,0,1/    ! ?
      DATA (KY(I),I=850,920)/
     &     0,3,5,6,5,3,2,3,2,2,7,8,8,7,1,0,0,  ! @
     &     0,9,9,0,0,                        ! [
     &     0,9,0,                            ! \
     &     0,9,9,0,0,                        ! ]
     &     0,4,8,4,                          ! ^
     &     0,                                ! _
     &     0,7,9,9,7,                        ! `
     &     0,9,9,8,5,4,3,1,0,0,              ! {
     &     0,8,5,0,4,1,                      !
     &     0,9,9,8,5,4,3,1,0,0,              ! }
     &     0,3,4,4,5/                        ! >
      DATA VFF,SX,TANA,XBREIT/1.,1.,0.,0./ ! VERZERRUNG,SPIEGELUNG,NEIGU
      ZEN=.FALSE.                            ! SYMBOL ENTRY
      HEIGHT=HEIGH           ! ZEICHENHOEHE
      NCHAR=NCH
      RSTX=HEIGHT/9.
      RSTY=RSTX
      ICON=0                                 ! KEINE WANDLUNG GROSS-KLEI
      LTEXTL=.FALSE.         ! KENNUNG KEINE TEXTLAENGE
C
      PENS=3                                 ! PEN UP
C
      IF (NCHAR.LT.0) THEN
         ZENS=ICHAR(STRING(1:1))             ! DAS ERSTE ZEICHEN WIRD
         GOTO 5                              ! ALS ZENTRIESRTES SYMBOL
      END IF                                 ! UND AUSGEGEBEN
C
      GOTO 10
C
      ENTRY TEXTLQ(TLEIN,TLAUS,HEIN,STRING,HAUS,NCH) ! TEXTLAENGE BERECH
      HEIGHT=1.0
      LTEXTL=.TRUE.
      TLAUX=0.
      XW=1.
      YH=1.
      YW=0.
      XH=0.
      X0=0.
      Y0=0.
      RSTX=1/9.
      RSTY=1/9.
      ZEN=.FALSE.
      NCHAR=NCH
      ICON=0
      GOTO 20
      ENTRY ZSYMBG (XPAGE,YPAGE,HEIGH ,ZENSA,ANGLE,ICODE)
      HEIGHT=HEIGH
C
      ZENS=ZENSA
      ICON=0
5     ZEN=.TRUE.
      NCHAR=1
C
      RSTX=HEIGHT/8.
      RSTY=RSTX
C
      IF (ABS(ICODE).EQ.2) THEN    ! PEN DOWN
         PENS=2
      ELSE
         PENS=3                    ! PEN UP
      END IF
10    ALPHA=ANGLE*ATAN(1.0)*8.0/360. ! UMWANDLUNG IN BOGENMASS
C TRANSFORMATIONSMATRIX
      YH=COS(ALPHA)          !
      XW=YH*SX*VFF          ! SX=1.0: NORMAL , SX=-1. :SPIEGEL
      YW=SIN(ALPHA)
      XH=-YW*SX
      YW=YW*VFF
      XPAUSE=XW*XBREIT       ! ZUSAETZLICHER ZEICHENABSTAND
      YPAUSE=YW*XBREIT       ! ZUSAETZLICHER ZEICHENABSTAND
C
      PEN=2                          ! PEN DOWN
C
      IF (XPAGE.EQ.999.0) THEN
         X0=XPNEU                    ! ALTE WERTE
      ELSE
         X0=XPAGE                    ! NEUE WERTE
      END IF
      IF (YPAGE.EQ.999.0) THEN
         Y0=YPNEU                    ! ALTE WERTE
      ELSE
         Y0=YPAGE                    ! NEUE WERTE
      END IF
C
      IF(ZEN) GOTO 40
C
C HIER ABFRAGE, OB DER STRING LEER IST
      IF(NCHAR.GT.0) THEN
      ITEST=0
      DO 30 IPOS=1,NCHAR
      IF(STRING(IPOS:IPOS).NE.' ') ITEST=1
   30 CONTINUE
      ENDIF
C     IF(ITEST.EQ.0) PEN=3
      IF(ITEST.EQ.0) GOTO 20
40    CALL PLOT (X0,Y0,PENS)      ! POSITION ANFAHREN
C
C ES FOLGT DIE HAUPTSCHLEIFE MIT DER ZEICHENWEISEN AUSGABE VON 'STRING'
C
20    NCHAR=ABS(NCHAR)       ! WEITER FUER SYMBOL,TEXTL
      LDASYA=LDASYM          ! DASH-ZUSTAND
      LDASYM=0               ! DASH-ZUSTAND : DASH VERBOTEN
      DO 100 IPOS=1,NCHAR
C
      IF (ZEN) THEN                   ! ZENTRIERTES SYMBOL
         IPOINT=ZENS                  ! CODE FUER SYMBOL
         IF (IPOINT.LT.0.OR.IPOINT.GT.14) THEN
            IF(NCERR.LT.60)PRINT *,'*** UNGUELTIGES ZSYMBL:',IPOINT
            NCERR=NCERR+1
            RETURN
         END IF
      ELSE
         IPOINT=ICHAR(STRING(IPOS:IPOS)) ! DAMIT IN IPOINT DER ASCII-COD
C                                        ! DES AUSZUGEBENDEN ZEICHENS
         IF (IPOINT.LT.32.OR.IPOINT.GT.126) THEN
           IF(NCERR.LT.60) THEN
          PRINT *,' DAS',IPOS,'-TE ZEICHEN VON NCHAR=',NCHAR,' IST KEIN'
     *  ,' GUELTIGES ASCII-ZEICHEN (ICHAR=',IPOINT,'):=>TEXTENDE. TEXT:'
            IPOINT= MIN(131,NCHAR)
            PRINT *,STRING(1:IPOINT)
            NCERR=NCERR+1
            ENDIF
            GOTO 350                  ! DA RESTZEICHEN ENTFALLEN *****
         END IF
         IF (.NOT.LGKS) THEN
            IF (STRING(IPOS:IPOS).EQ.'<') THEN     ! WANDELN
               ICON=0
               GOTO 100
            END IF
            IF (STRING(IPOS:IPOS).EQ.'>') THEN     ! NICHT WANDELN
               ICON=32
               GOTO 100
            END IF
         END IF
         IF (IPOINT.GE.ICHAR('A').AND.IPOINT.LE.ICHAR('Z'))
     &    IPOINT=IPOINT+ICON
      END IF
      IF(LTEXTL.AND.IPOS.NE.NCHAR)GOTO 300  ! NUR LETZTES ZEICHEN LAENGE
         LEN=CHALEN(IPOINT)
         IF (LEN.NE.0) THEN        ! SONST BLANK BZW. NICHT IMPLEMENTIER
           IPOINT=INDEX(IPOINT)    ! ZEICHEN INNERHALB DES ARRAYS
           DO 110 I=1,LEN
           IF (KX(IPOINT+I-1).EQ.99) THEN
             PEN=3                    ! PEN UP
           ELSE
C ES WIRD EINE NEUE KOORDINATE MIT PEN DOWN ANGEFAHREN
             HVY=FLOAT(KY(IPOINT+I-1))*RSTY
             HVX=(FLOAT(KX(IPOINT+I-1))*RSTX+HVY*TANA)*VFF ! NEIGUNG
C TRANSFORMIEREN
             LPX=X0+HVX*XW+HVY*XH
      IF(LTEXTL)TLAUX=AMAX1(TLAUX,LPX) ! MAX LAENGE SUCHEN
      IF(LTEXTL)GOTO 110     ! NUR MAX LAENGE SUCHEN
             LPY=Y0+HVX*YW+HVY*YH
C AUSGEBEN
             CALL PLOT (LPX,LPY,PEN)
             PEN=2                    ! PEN DOWN
           END IF
110        CONTINUE
         END IF
300   IF (.NOT.ZEN) THEN
       X0=X0+HEIGHT*(XW+XPAUSE)   ! POSITION NEUES ZEICHEN
         Y0=Y0+HEIGHT*(YW+YPAUSE)     !
C          IF(.NOT.LTEXTL) CALL PLOT(X0,Y0,3) ! NAECHSTES ZEICHEN
           IF(.NOT.LTEXTL.AND.ITEST.EQ.1) CALL PLOT (X0,Y0,3) !
C          IF(.NOT.LTEXTL.AND.ITEST.EQ.0) IPENA=3             !
      END IF
100   CONTINUE
350   CONTINUE
      LDASYM=LDASYA          ! DASH-ZUSTAND WIE BEGINN
      IF(LTEXTL)GOTO 400     ! TEXTLAENGE
      IF (ZEN) RETURN                 ! POSITION BLEIBT
C
C NEUE PEN-POSITION RETTEN
C
      XPNEU=X0
      YPNEU=Y0
      XPAGE=XPNEU
      YPAGE=YPNEU
C
      RETURN
400   TLAUX=AMAX1(TLAUX,X0-HEIGHT*(XW+XPAUSE))
      TLAUS=TLAUX*HEIN
      HAUS=TLEIN/TLAUX
      RETURN
C     ------------------------------------------------------------
C      ENTRY SYMBLH(VERZ,ISPIEG,WNEIG,IINT)
C     RVFELD=(VERZ,WNEIG,DICKE),   IVFELD=(INTENS,ISPIEG,IINT)
      ENTRY SYMBQV(RVFELD,IVFELD,NRV,NIV)
C     SCHRIFTDICKE, INTENSITAET SIND BEI SYMBLK NICHT AUSWERTBAR
C           ======
      IF(NRV.LE.0)GOTO 375
      IF (RVFELD(1).LT..2.OR.RVFELD(1).GT.5.) GOTO 370
      VF = RVFELD(1)
      VFF = RVFELD(1)
370   IF(NRV.LE.1)GOTO 375
      IF (RVFELD(2).LT.45.0.OR.RVFELD(2).GT.135.) GOTO 371
      PSI = RVFELD(2)
      TANA = TAN((90.- PSI)*ATAN(1.0)*8.0/360.) ! NEIGUNG
371   IF(NRV.LE.2)GOTO 375
      IF (RVFELD(3).LT.-2.0.OR.RVFELD(3).GT.1.01) GOTO 375
      XBREIT=RVFELD(3)       ! ZEICHENABSTAND
375   IF(NIV.LE.1)RETURN     ! INTENSITAET GEHT NICHT
      SX = 1.0
      IF (IVFELD(2).EQ.1) SX = -1.0
376   IF(NIV.LE.2)RETURN     ! INTENSITAET GEHT NICHT
      IFFLB=0
C     0  =  GERADE,   1  =  PARABEL
      IF (IVFELD(3).EQ.1)IFFLB= 1
      RETURN
C
       END
C      ENTRY SYMBLH(VERZ,ISPIEG,WNEIG,IINT)
