C     COMPUTE EIGENVECTORS AND EIGENVALUES OF REAL SYMMETRIC MATRIX
      SUBROUTINE EIGEN2 (B,V,IND)
      DIMENSION B(3,3),V(3,3),IND(3)
      DO 1020 I=1,3
      DO 1000 J=1,3
      V(I,J)=0.0
 1000 CONTINUE
      V(I,I)=1.0
 1020 CONTINUE
 1040 KNT=0
      IND1=1
      IND3=1
      DO 1500 I=1,2
      IP1=I+1
      DO 1460 J=IP1,3
      IF (ABS(B(I,J)) .LT. 0.000001 * B(IND1,IND1)) KNT = KNT + 1
      BIJ=B(I,I)-B(J,J)
      IF(ABS(B(I,J)).LT.ABS(BIJ))GO TO 1100
      T=SIGN(1.0,B(I,J)*BIJ)
      GO TO 1180
 1100 T=B(I,J)/BIJ
 1180 G=T/(2.0+2.0*T*T)
      SN=2.0*G/(1.0+G*G)
      CS=1.0-G*SN
      DO 1200 K=1,3
      BIK=B(I,K)
      B(I,K)=CS*B(I,K)+SN*B(J,K)
      B(J,K)=CS*B(J,K)-SN*BIK
 1200 CONTINUE
      DO 1220 K=1,3
      BKI=B(K,I)
      B(K,I)=CS*B(K,I)+SN*B(K,J)
      B(K,J)=CS*B(K,J)-SN*BKI
      VKI=V(K,I)
      V(K,I)=CS*V(K,I)+SN*V(K,J)
      V(K,J)=CS*V(K,J)-SN*VKI
 1220 CONTINUE
 1460 CONTINUE
      IF(B(IP1,IP1).GT.B(IND1,IND1))IND1=IP1
      IF(B(IND3,IND3).GT.B(IP1,IP1))IND3=IP1
 1500 CONTINUE
      IF(KNT.LT.3)GO TO 1040
      IND(1)=IND1
      IND(2)=1
      IND(3)=IND3
      IF(IND1.EQ.IND(2).OR.IND3.EQ.IND(2))IND(2)=2
      IF(IND1.EQ.IND(2).OR.IND3.EQ.IND(2))IND(2)=3
C     CHECK FOR RIGHT-HANDED SET OF VECTORS
      DET = V(1,1)*(V(2,2)*V(3,3)-V(2,3)*V(3,2))+V(1,2)*(V(2,3)*V(3,1)
     1  -V(2,1)*V(3,3))+V(1,3)*(V(2,1)*V(3,2)-V(2,2)*V(3,1))
      IF (DET .GT. 0.0) RETURN
      DO 1520 I=1,3
      V(I,3) = -V(I,3)
 1520 CONTINUE
      RETURN
      END
