C     ***** OAK RIDGE THERMAL ELLIPSOID PLOT PROGRAM *****
C *** FORTRAN DECK IS BCD/IBM-026-KEYPUNCH
C   ***** OAK RIDGE THERMAL ELLIPSOID PLOT PROGRAM *****
C    ***** ORTEP-II / IBM-360 / FEB 1971 / INSTRUCTIONS IN ORNL-3794 **
C    ***** OPTIONAL OVERLAP FEATURE ADDED TO ORTEP IN FEBRUARY 1971 ***
C    ***** CUBANE EXAMPLE CARDS ILLUSTRATE USE OF OVERLAP FEATURE *****
C    ***** IN BRIEF, INSTRUCTION 511 MAY BE USED JUST BEFORE EACH
C    ***** DRAWING TO STORE THE PROJECTED ATOMS, TYPE 2 TRAILER CARDS
C    ***** WITH INSTR 511 CAUSES PROJECTED BONDS ALSO TO BE STORED
C    ***** THE SAME TYPE 2 TRAILER CARDS USED BY THE 802/812 INSTR. ***
C    ***** COLS 10-18 ON 511 INSTR CARD SPECIFIES OVERLAP MARGIN(OVMRGN)
C    *****        0       OVMRGN   MAX(0.025 OR SQRT(SCAL1)*0.030)
C    *****     1 OR -1    OVMRGN   0.0
C    *****    .GT.0,.LT.1 OVMRGN   ACTUAL VALUE GIVEN (CENTIMETERS) ***
C    ***** ALL OVERLAPP INFORMATION IS DESTROYED BY INSTR. 501-510
C    ***** IF THE COMPUTER MEMORY AVAILABLE IS EXCEEDED BY THIS FEATURE
C    ***** SUBROUTINE LAP500,LAP700,LAP800,LAPDRW,LAPAB AND LAPCON
C    ***** MAY BE REMOVED AND REPLACED BY THE FOLLOWING 4 DUMMIES
C    SUBROUTINE LAP500(NTYPE)
C    RETURN
C    END
C    SUBROUTINE LAP700(NA,ICQ)
C    RETURN
C    END
C    SUBROUTINE LAP800(NA1,NA2,ICQ)
C    RETURN
C    END
C    SUBROUTINE LAPDRW(Y,NPEN,NCQ)
C    RETURN
C    END
      PROGRAM MAIN
      DIMENSION A(9),AA(3,3),AAREV(3,3),AAWRK(3,3),AID(3,3),AIN(140)
      DIMENSION ATOMS(4,500),BB(3,3),CD(8,10),   CONT(5),D(3,130)
      DIMENSION DA(3,3),DP(2,130),EV(3,100),FS(3,3,48),KD(5,10),ORGN(3)
      DIMENSION P(3,100),PA(3,3,100),PAC(3,5),PAT(3,3),Q(3,3),REFV(3,3)
      DIMENSION RES(4),RMS(5),SYMB(3,3),       TS(3,48)
      DIMENSION VT(3,4),V1(4),V2(3),V3(3),V4(3),V5(3),V6(3),WRKV(3,3)
      DIMENSION XLNG(3),XO(3),XT(3)
      COMMON NG,A,AA,AAREV,AAWRK,AID,AIN,ATOMS,BB,BRDR,CD,   CONT,D
      COMMON DA,DP,DISP,EDGE,EV,FORE,FS,IN,ITILT,KD,LATM,LTNO,NATOM,NCD
      COMMON NJ,NJ2,NOUT,NSR,NSYM,ORGN,P,PA,PAC,PAT,Q,REFV,RES,RMS,SCAL1
      COMMON SCAL2,SCL,SYMB,TAPER,THETA,       TS,VIEW,VT,V1,V2
      COMMON V3,V4,V5,V6,WRKV,XLNG,XO,XT
      COMMON SHIFTX,SHIFTY
      CHARACTER*6 CHEM(100), TITLE(18)*4, TITLE2(18)*4
      COMMON /LABEL/ CHEM, TITLE, TITLE2
      OPEN(16,STATUS='SCRATCH',FORM='UNFORMATTED')
      PI=4*ATAN(1.)
    2 CALL PRIME
C     ***** READ JOB TITLE CARD *****
      READ (IN,4,END=1200)(TITLE(I),I=1,18)
    4 FORMAT(18A4)
      WRITE (NOUT,6)(TITLE(I),I=1,18)
    5 FORMAT(1H0,10X,18A4)
    6 FORMAT(1H1,10X,18A4)
      CALL PRELIM
      WRITE (NOUT,6)(TITLE(I),I=1,18)
      ISAVE=0
      GO TO 507
    7 ISAVE=0
C     ***** ZERO AIN ARRAY *****
    8 DO 10 J=1,140
   10 AIN(J)=0.
   11 FORMAT(1H0,4X,17H((((( INSTRUCTION,I5,6H ))))))
   12 FORMAT(I3,I6,7F9.0)
   13 FORMAT(I3,I6,7E15.8)
   14 FORMAT(1H ,9X,7E15.7)
C     ***** READ NEW INSTRUCTION CARD *****
      NCD=0
      N1=-6
   16 N1=N1+7
      N2=N1+6
      IF(ISAVE)22,18,18
   18 READ (IN,12)IC,NF,(AIN(I),I=N1,N2)
      IF(ISAVE)24,24,20
   20 WRITE (NSR)IC,NF,(AIN(I),I=N1,N2)
      GO TO 24
   22 READ (NSR)IC,NF,(AIN(I),I=N1,N2)
      IF(IC)7,24,24
   24 IF(N1-1)26,26,30
   26 WRITE (NOUT,11)NF
      NF1=NF
      IF(NF1)  28,8,30
   28 IF(NF1+2)  2,2,3000
   30 WRITE (NOUT,14)(AIN(I),I=N1,N2)
   32 IC=IC+1
      GO TO (90,16,38,50),IC
   33 FORMAT(I3,6X,5I3,8F6.0)
   34 FORMAT(6I3,8E12.5)
   35 FORMAT(1H ,11X,5I3,8F11.5)
C     ***** READ FORMAT 2 TRAILER CARDS *****
   38 NCD=NCD+1
      IF(ISAVE)44,40,40
   40 READ (IN,33)IC,(KD(I,NCD),I=1,5),(CD(I,NCD),I=1,8)
      IF(ISAVE)46,46,42
   42 WRITE (NSR)IC,(KD(I,NCD),I=1,5),(CD(I,NCD),I=1,8)
      GO TO 46
   44 READ (NSR)IC,(KD(I,NCD),I=1,5),(CD(I,NCD),I=1,8)
   46 WRITE (NOUT,35)(KD(I,NCD),I=1,5),(CD(I,NCD),I=1,8)
      GO TO 32
C     ***** READ FORMAT 3 TRAILER CARD *****
   50 IF(ISAVE)52,54,54
   52 READ (NSR)(TITLE2(I),I=1,18)
      GO TO 55
   54 READ (IN ,4)(TITLE2(I),I=1,18)
   55 WRITE (NOUT,5)(TITLE2(I),I=1,18)
      IF(ISAVE)90,90,56
   56 WRITE (NSR)(TITLE2(I),I=1,18)
C     ***** EXECUTE INSTRUCTION *****
   90 NJ=NF1/100
      NJ2=NF1-NJ*100
      NJ3=MOD(NJ2,10)
      IF(NJ-12)98,92,92
   92 CALL SPARE(NF1)
      IF(NG)94,8,94
   94 CALL ERPNT(0.,NF1)
      GO TO 8
C     ******BRANCH TABLE FOR FUNCTION TYPES******
   98 GO TO(100,200,300,400,500,600,700,800,900,1000,1100),NJ
C     *******STRUCTURE ANALYSIS FUNCTIONS*******
  100 GO TO (101,101,104,104,101,101,94,101,94),NJ2
  101 CALL SEARC
      GO TO 8
C     ***** ANISOTROPIC TEMP FACTOR OUTPUT *****
  104 DO 164 I=1,NATOM
      IF(MOD(I,14)-1)134,114,134
  114 WRITE (NOUT,6)(TITLE(J),J=1,18)
      WRITE (NOUT,129)
  129 FORMAT(1H0,10X,4HATOM,3X,16HRMS DISPLACEMENT,3X,31HROW VECTORS, BA
     &SED ON REFERENCE,17X,29HPROBABILITY COVARIANCE MATRIX,3X,11HHAMILT
     &ONS B)
  134 T1=55501.+FLOAT(I)*100000.
      CALL PAXES(T1,-3)
      IF(NG)144,154,144
  144 CALL ERPNT(T1,104)
  149 FORMAT(1H0,10X,A6,F10.6,6X,3F12.7,10X,3F12.7,F9.2)
  154 IF (ABS(Q(1,2))+ABS(Q(1,3))+ABS(Q(2,3)) +ABS(Q(2,2)-Q(1,1))
     1 +ABS(Q(2,2)-Q(3,3)) .LT. 0.00001) GOTO 155
      BHAM= 8./3.*PI*PI*(Q(1,1)+Q(2,2)+Q(3,3))
      WRITE (NOUT,149)CHEM(I),RMS(1),(PAC(J,1),J=1,3),(Q(J,1)
     1 ,J=1,3), BHAM
      GOTO 164
  155 WRITE (NOUT,149)CHEM(I),RMS(1),(PAC(J,1),J=1,3),(Q(J,1), J=1,3)
  164 WRITE (NOUT,159)(RMS(K),(PAC(J,K),J=1,3),(Q(J,K),J=1,3)
     1,K=2,3)
  159 FORMAT(1H ,16X,F10.6,6X,3F12.7,10X,3F12.7)
      GO TO 8
C     *******PLOTTER INITIALIZE,FRAME ADVANCE,TERMINATE FUNCTIONS*******
  200 CALL F200
      GO TO 8
  300 GO TO (301,302,303,94),NJ2
C     *******PLOT DIMENSIONS*******
  301 IF(AIN(1))321,321,311
  311 XLNG(1)=AIN(1)
  321 IF(AIN(2))341,341,331
  331 XLNG(2)=AIN(2)
  341 IF(AIN(3))  361,351,351
  351 VIEW=AIN(3)
  361 IF(AIN(4))381,381,371
  371 BRDR=AIN(4)
  381 WRITE (NOUT,389)XLNG(1),XLNG(2),BRDR
  389 FORMAT(1H0,10X,11HPLOT LIMITS,F6.2,3H BY,F6.2,15H CM.  INCLUDING,F
     &6.2,12H  CM. MARGIN)
  391 WRITE (NOUT,399)VIEW
  399 FORMAT(1H ,10X,13HVIEW DISTANCE,F7.3,12H CENTIMETERS)
      GO TO 8
C     *******LEGEND ROTATION*******
  302 THETA=AIN(1)
      T1=THETA*.01745329252
      COSTH=COS(T1)
      SINTH=SIN(T1)
      DO 312 J=1,9
  312 SYMB(J,1)=0.
      SYMB(1,1)=COSTH
      SYMB(2,2)=COSTH
      SYMB(3,3)=1.
      SYMB(2,1)=SINTH
      SYMB(1,2)=-SINTH
      WRITE (NOUT,319)THETA
  319 FORMAT(1H0,10X,44HREGULAR TITLE AND SYMBOL ROTATION IN DEGREES,F8.
     &2)
      GO TO 8
C     ***** RETRACE DISPLACEMENT *****
  303 DISP=AIN(1)
      WRITE (NOUT,313)DISP
  313 FORMAT(1H0,10X,22HRETRACE DISPLACEMENT =,F7.4,11H CENTIMETER)
      GO TO 8
C     *******ATOM LIST FUNCTIONS*******
  400 GO TO (401,401,401,401,401,401,490, 94, 94,410,
     1       401,401,401,401,401,401, 94),NJ2
  401 CALL F400
      GO TO 490
  410 LATM=0
      DO 420 I=1,500
      DO 420 J=1,4
  420 ATOMS(J,I)=0.
  490 IF(LATM)8,8,491
  491 WRITE (NOUT,499)(ATOMS(1,I),I=1,LATM)
  499 FORMAT(1H0,10X,23HCONTENTS OF ATOMS ARRAY/(15X,10F10.0))
      GO TO 8
C     *******CARTESIAN COORDINATE SYSTEM FUNCTIONS*******
  500 CALL F500
      WRITE  (NOUT,503) (ORGN(J),J=1,3)
  503 FORMAT(1H0,10X,44HORIGIN FOR PROJECTION AXIS IN CRYSTAL COORD.,3F1
     &5.6)
      IF(MOD(NJ2,10)-3)  507,539,601
  507 WRITE (NOUT,529)
      WRITE (NOUT,519)((REFV(J,I),I=1,3),(AAREV(J,I),I=1,3),J
     1=1,3)
      GO TO 8
  509 FORMAT(1H0,10X,49HORTHONORMAL WORKING VECTORS BASED ON CRYSTAL AXE
     &S,18X,33HPOST-FACTOR TRANSFORMATION MATRIX/16X,8HX VECTOR,8X,8HY V
     &ECTOR,8X,8HZ VECTOR)
  519 FORMAT(1H ,10X,3E16.7,8X,3E16.7)
  529 FORMAT(1H0,10X,51HORTHONORMAL REFERENCE VECTORS BASED ON CRYSTAL A
     &XES,16X,33HPOST-FACTOR TRANSFORMATION MATRIX/16X,8HX VECTOR,8X,8HY
     & VECTOR,8X,8HZ VECTOR)
  539 WRITE (NOUT,509)
      WRITE (NOUT,519)((WRKV(J,I),I=1,3),(AAWRK(J,I),I=1,3),J
     1=1,3)
      GO TO 8
C     *******PLOT CENTERING FUNCTIONS*******
  600 CALL F600
  601 WRITE (NOUT,609)  XO(1),XO(2),SCAL1,SCAL2
  609 FORMAT(1H0,10X,31HORIGIN POINT IN PLOTTER COORD.(,F6.2,2H ,,F6.2,8
     &H ) CM.  /11X,15HOVERALL SCALE =,F6.3,30H CM/ANGSTROM ELLIPSOID SC
     &ALE =,F6.3)
      GO TO 391
C     *******ELLIPSOID AND SYMBOL PLOT FUNCTIONS*******
C     ********FILL OUT DETAILS FOR SPECIAL MODELS********
  700 GO TO (701,702,704,705,709,94),NJ3
  701 AIN(3)=8.
      GO TO 703
  702 AIN(3)=0.
  703 AIN(1)=4.
      AIN(2)=0.
      AIN(4)=0.
      GO TO 709
  704 AIN(1)=3.
      AIN(2)=-5.
      GO TO 706
  705 AIN(1)=1.
      AIN(2)=0.
  706 AIN(3)=1.
      AIN(4)=5.
  709 CALL F700
      GO TO 8
C     *******BOND FUNCTIONS*******
  800 CALL F800
      GO TO 8
C     *******TITLE FUNCTIONS*******
  900 CALL F900
      GO TO 8
C     *******CELL OUTLINE FUNCTIONS*******
 1000 CALL F1000
      GO TO 8
C     *******SAVE SEQUENCE FUNCTIONS*******
 1100 IF(NJ2-2)1101,1102,1103
 1101 ISAVE=1
      GO TO 1104
 1102 ISAVE=0
      J=-1
      END FILE NSR
      GO TO 1104
 1103 ISAVE=-1
 1104 REWIND NSR
      GO TO 8
C     ***** TERMINATE PLOTTER TAPE IF NECESSARY *****
 3000 IF(LTNO)  3005,3010,3005
 3005 AIN(1)= -.000001
      AIN(2)=0.0
      NJ2=3
      CALL F200
 3010 CONTINUE
 1200 CONTINUE
      CLOSE(16)
      END
