      SUBROUTINE PRELIM
C     ***** DATA INPUT ROUTINE *****
      DIMENSION B(9)
      DIMENSION A(9),AA(3,3),AAREV(3,3),AAWRK(3,3),AID(3,3),AIN(140)
      DIMENSION ATOMS(4,500),BB(3,3),CD(8,10),   CONT(5),D(3,130)
      DIMENSION DA(3,3),DP(2,130),EV(3,100),FS(3,3,48),KD(5,10),ORGN(3)
      DIMENSION P(3,100),PA(3,3,100),PAC(3,5),PAT(3,3),Q(3,3),REFV(3,3)
      DIMENSION RES(4),RMS(5),SYMB(3,3),       TS(3,48)
      DIMENSION VT(3,4),V1(4),V2(3),V3(3),V4(3),V5(3),V6(3),WRKV(3,3)
      DIMENSION XLNG(3),XO(3),XT(3)
      COMMON NG,A,AA,AAREV,AAWRK,AID,AIN,ATOMS,BB,BRDR,CD,   CONT,D
      COMMON DA,DP,DISP,EDGE,EV,FORE,FS,IN,ITILT,KD,LATM,LTNO,NATOM,NCD
      COMMON NJ,NJ2,NOUT,NSR,NSYM,ORGN,P,PA,PAC,PAT,Q,REFV,RES,RMS,SCAL1
      COMMON SCAL2,SCL,SYMB,TAPER,THETA,       TS,VIEW,VT,V1,V2
      COMMON V3,V4,V5,V6,WRKV,XLNG,XO,XT
      COMMON SHIFTX,SHIFTY
      CHARACTER*6 CHEM(100), TITLE(18)*4, TITLE2(18)*4
      COMMON /LABEL/ CHEM, TITLE, TITLE2
      CHARACTER*6 IDENT,KDENT,LDENT
      CHARACTER SYM1*2, SYM2*3
C
C     ***** CELL DIMENSIONS *****
  106 FORMAT(6F9.6)
      READ (IN,106)(A(I),I=1,6)
      T1=ABS(A(4))-1.
      DO 125 J=1,3
      IF(T1)115,110,110
C     ***** CELL ANGLES IN DEGREES *****
  110 A(J+6)=A(J+3)
      A(J+3)=COS(A(J+6)*.01745329252)
      GO TO 120
C     ***** COSINES OF CELL ANGLES *****
  115 A(J+6)=ARCCOS(A(J+3))
C     ***** STORE IDEMFACTOR MATRIX *****
  120 AID(J,J)=1.
      AID(J+1,1)=0.
      AID(J+5,1)=0.
C     ***** STORE METRIC TENSOR *****
  125 AA(J,J)=A(J)**2
      AA(1,2)=A(1)*A(2)*A(6)
      AA(1,3)=A(1)*A(3)*A(5)
      AA(2,3)=A(2)*A(3)*A(4)
      AA(2,1)=AA(1,2)
      AA(3,1)=AA(1,3)
      AA(3,2)=AA(2,3)
C     ***** INVERT METRIC TENSOR *****
      CALL AXEQB(AA,BB,AID,3)
C     ***** CALCULATE RECIPROCAL CELL PARAMETERS *****
      DO 128 J=1,3
  128 B(J)=SQRT(BB(J,J))
      B(6)=BB(1,2)/(B(1)*B(2))
      B(5)=BB(1,3)/(B(1)*B(3))
      B(4)=BB(2,3)/(B(2)*B(3))
      DO 130 J=1,3
  130 B(J+6)=ARCCOS(B(J+3))
C     ***** WAS INPUT FOR REAL OR RECIPROCAL CELL *****
      IF(A(1)-1.)135,150,150
  135 DO 140 J=1,9
      T1=AA(J,1)
      AA(J,1)=BB(J,1)
      BB(J,1)=T1
      T1=A(J)
      A(J)=B(J)
  140 B(J)=T1
C     ***** WRITE OUT CELL PARAMETERS *****
  143 FORMAT(1H0,10X,22HDIRECT CELL PARAMETERS/1H ,15X,1HA,14X,1HB,14X,1
     &HC,14X,5HALPHA,10X,4HBETA,11X,5HGAMMA)
  145 FORMAT(1H ,10X,F9.6,2F15.6,3F15.3/1H ,48X,6HCOSINE,F12.8,2F15.8)
  147 FORMAT(1H0,10X,26HRECIPROCAL CELL PARAMETERS/1H ,15X,2HA*,13X,2HB*
     &,13X,2HC*,13X,6HALPHA*,9X,5HBETA*,10X,6HGAMMA*)
  150 WRITE (NOUT,143)
      WRITE (NOUT,145)(A(I),I=1,3),(A(I),I=7,9),(A(I),I=4,6)
      WRITE (NOUT,147)
      WRITE (NOUT,145)(B(I),I=1,3),(B(I),I=7,9),(B(I),I=4,6)
C     ***** STORE STANDARD VECTORS *****
      CALL AXES(AID,AID(1,2),REFV,0)
      CALL MM(AA,REFV,AAREV)
      DO 160 I=1,3
      DO 160 J=1,3
      AAWRK(J,I)=AAREV(J,I)
      Q(J,I)=REFV(I,J)
  160 WRKV(J,I)=REFV(J,I)
C     ***** READ AND WRITE SYMMETRY TRANSFORMATIONS *****
  171 FORMAT(1H0,10X,24HSYMMETRY TRANSFORMATIONS/1H ,14X,3HNO.,12X,13HTR
     &ANSFORMED X,18X,13HTRANSFORMED Y,18X,13HTRANSFORMED Z)
  173 FORMAT(I1,F14.9,3F3.0,2(F15.9,3F3.0))
  175 FORMAT(1H ,13X,I2,3(F13.6,F4.0,2H X,F4.0,2H Y,F4.0,2H Z))
  177 FORMAT(1H1,10X,18A4)
      WRITE (NOUT,171)
      LINES=14
      DO 190 I=1,48
      LINES=MOD(LINES+1,56)
      READ (IN,173)IS,(TS(J,I),(FS(K,J,I),K=1,3),J=1,3)
      IF(LINES)185,180,185
  180 WRITE (NOUT,177)(TITLE(J),J=1,18)
      WRITE (NOUT,171)
  185 WRITE (NOUT,175)I,(TS(J,I),(FS(K,J,I),K=1,3),J=1,3)
C     ***** NON-CRYSTALLOGRAPHIC HELIX-SYMMETRY INPUT *****
      IF(FS(3,3,I)-5.)188,186,186
  186 T1=FS(1,3,I)/FS(3,3,I)
      TS(3,I)=TS(3,I)+T1
      T1=AMOD(T1*FS(2,3,I),1.)*6.28318531
      T2=COS(T1)
      T1=SIN(T1)
      DO 187 J=1,9
  187 VT(J,1)=AID(J,1)
      VT(1,1)=T2
      VT(2,2)=T2
      VT(2,1)=-T1
      VT(1,2)=T1
      CALL MM(VT,Q,PAC)
      CALL MM(AAREV,PAC,FS(1,1,I))
C ATOMPARAMETERKARTEN DES X-RAY SYSTEMS SOLLEN EINGELESEN WERDEN,WENN ZU
C DER TERMINATOR DER SYMMETRIEKARTEN DEN WERT 9 HATTE. ALS TERMINATOR DE
C PARAMETERKARTEN GILT EINE AUF DER LETZTEN TEMPERATURFAKTORKARTE IN SPA
C GESTANZTE 9.
C                 AENDERUNG HENKE JUNI 1975
C
C BESITZT DER TERMINATOR DER SYMMETRIEKARTEN DEN WERT 8, SO WERDEN KARTE
C SHELDRICK-FORMAT EINGELESEN; ALS TERMINATOR DER SHELDRICK-PARAMETERKAR
C GILT DIE 8 IN SPALTE 7 DER KARTE MIT DEN ORTSPARAMETERN, ALSO NICHT WI
C X-RAY SYSTEM DER TEMPERATURFAKTORKARTE, WGHT- UND FVAR-KARTEN WERDEN I
C RIERT; SOLL U11 AUF DER 1.KARTE DEN RADIUS DES ATOMS IN ANGSTROEMEINHE
C REPRAESENTIEREN (TYP 7 DES TEMPERATURFAKTORS BEI JOHNSON), SO MUSS SPA
C 72 - 80 DEN WERT 7. ENTHALTEN.
C                 AENDERUNG HENKE JUNI 1984
      IISS=0
  188 IF(IS)   195,190,195
  190 CONTINUE
      NG=1
      CALL ERPNT(0.,0)
      I=48
  195 IF(IS.GT.6)   IISS=-IS
      NSYM=I
C     ***** POSITIONAL AND THERMAL PARAMETERS *****
  207 FORMAT(11H0 NO. ATOM ,8X,1HX,10X,1HY,10X,1HZ,13X,3HB11,8X,3HB22,8X
     &,3HB33,8X,3HB12,8X,3HB13,8X,10HB23   TYPE)
  209 FORMAT(1H ,I3,1X,A6,3F11.6,5X,6F11.6,F5.0)
  210 FORMAT(1H ,I3,1X,A6,3F11.6,5X,2F11.6,4F11.0,F5.0)
  211 FORMAT(A6,3X,5F9.6,F9.0)
  213 FORMAT(I1,F8.6,5F9.6,F9.0)
      LINES=LINES+2
      IF(LINES-56)220,215,215
  215 LINES=-1
      GO TO 225
  220 WRITE (NOUT,207)
  225 DO 245 I=1,100
      LINES=MOD(LINES+1,56)
      IF(IISS.LT.0)  GO TO  191
      READ (IN,211)CHEM(I),V1(1),V1(2),(P(J,I),J=1,3),T1
      K=1.+T1
      IF(FLOAT(K-1)-T1)   227,228,227
  227 K=1
  228 READ(IN,213)  IS,(PA(J,1,I),J=1,7)
      GO TO 193
  191 IF(IISS+8)   200,1001,201
  200 READ(IN,194)  SYM1,SYM2,(P(J,I),J=1,3)
      T1=0.
      K=1.+T1
      READ(IN,196)  IDENT,IS,(PA(J,1,I),J=1,6)
      KDENT='UIJ'
      LDENT='B'
      PA(7,1,I)=0.
      IF(IDENT.EQ.KDENT)  PA(7,1,I)=8.
      IF(IDENT.EQ.LDENT)  PA(7,1,I)=6.
  194 FORMAT(7X,A2,1X,A3,3F8.0)
  196 FORMAT(A6,I1,6X,6F8.0)
      CHEM(I)=SYM1//SYM2//' '
      GO TO 193
  201 READ(IN,202)  (P(J,I),J=1,3),CHEM(I)
  202 FORMAT(3F10.0,44X,A6)
      T1=1.
      K=1.+T1
      READ(IN,213)  IS,(PA(J,1,I),J=1,7)
      GOTO 193
 1001 READ(IN,1002) CHEM(I),IS,(P(J,I),J=1,3),PA(1,1,I),PA(2,1,I),
     1 PA(7,1,I)
 1002 FORMAT(A6,I1,4X,3(F8.0,2X),10X,2(F8.0,2X),F9.0)
      IF (CHEM(I).EQ.'WGHT'.OR.CHEM(I).EQ.'FVAR') GOTO 1001
      IF (P(1,I).GT.5.) P(1,I)=P(1,I)-10.
      IF (P(2,I).GT.5.) P(2,I)=P(2,I)-10.
      IF (P(3,I).GT.5.) P(3,I)=P(3,I)-10.
      T1=0.
      K=1.+T1
      IF(PA(7,1,I).GE.6.999 .AND. PA(7,1,I).LE.7.001) THEN
      PA(7,1,I)=7.
      GOTO 193
      ENDIF
      IF(PA(2,1,I).LT.0.00001) THEN
      PA(1,1,I)=PA(1,1,I)*128.*(ATAN(1.))**2
      PA(7,1,I)=6.
      ENDIF
      IF(PA(2,1,I).GE.0.00001) THEN
      PA(7,1,I)=8.
      READ(IN,1003) PA(3,1,I),PA(6,1,I),PA(5,1,I),PA(4,1,I)
 1003 FORMAT(7X,4(F8.0,2X))
      IF (PA(1,1,I).GT.5.) PA(1,1,I)=PA(1,1,I)-10.
      IF (PA(2,1,I).GT.5.) PA(2,1,I)=PA(2,1,I)-10.
      IF (PA(3,1,I).GT.5.) PA(3,1,I)=PA(3,1,I)-10.
      IF (PA(4,1,I).GT.5.) PA(4,1,I)=PA(4,1,I)-10.
      IF (PA(5,1,I).GT.5.) PA(5,1,I)=PA(5,1,I)-10.
      IF (PA(6,1,I).GT.5.) PA(6,1,I)=PA(6,1,I)-10.
      ENDIF
  193 IF (LINES)   230,230,232
  230 WRITE (NOUT,177)(TITLE(J),J=1,18)
      WRITE (NOUT,207)
  232 IF(PA(3,1,I)-10000.)235,234,234
  234 WRITE (NOUT,210)I,CHEM(I),(P(J,I),J=1,3),(PA(J,1,I),J=1
     1,7)
      GO TO 238
  235 WRITE (NOUT,209)I,CHEM(I),(P(J,I),J=1,3),(PA(J,1,I),J=1
     1,7)
  238 GO TO (244,239,241,242,244),K
C     ***** TYPE 1 POSITIONAL PARAMETERS (ANGSTROMS) *****
  239 DO 240 J=1,3
  240 P(J,I)=P(J,I)/A(J)
      GO TO 244
C     ***** TYPE 2 POSITIONAL PARAMETERS, STANDARD CARTESIAN *****
  241 V1(1)=P(1,I)
      V1(2)=P(2,I)
      GO TO 243
C     ***** TYPE 3 POSITIONAL PARAMETERS *****
C     ***** CYLINDRICAL COORDINATES REFERRED TO STANDARD CARTESIAN *****
  242 T2=P(2,I)*.01745329252
      V1(1)=V1(1)+P(1,I)*COS(T2)
      V1(2)=V1(2)+P(1,I)*SIN(T2)
  243 V1(3)=P(3,I)
      CALL VM(V1,Q,P(1,I))
  244 IF(IS)246,245,246
  245 CONTINUE
      NG=2
      CALL ERPNT(0.,0)
      I=100
  246 NATOM=I
C     ***** CONVERT TEMP FACTOR COEF TO STANDARD TYPE ZERO *****
      NG1=0
      DO 450 I=1,NATOM
      T1=PA(1,1,I)
      K=1.+PA(7,1,I)
      IF(T1)250,250,255
  250 T1=.1
      GO TO 405
  255 T6=.0506605918
      GO TO (270,260,265,265,270,260,400,405,270,260,270,450),K
C     ***** TYPE 1 *****
  260 DO 262 J=4,6
  262 PA(J,1,I)=PA(J,1,I)*.5
      GO TO 270
C     ***** TYPES 2 AND 3 (BASE 2 SYSTEMS) *****
  265 T6=.351152464
      IF(K-4)270,260,270
C     ***** TYPES 0 THROUGH 5 *****
  270 IF(PA(2,1,I))400,400,272
  272 DO 300 J=1,3
      DO 300 L=J,3
      T2=T6
      IF(K-5)285,275,275
  275 IF(K-6)280,280,281
C     ***** TYPES 4 AND 5 *****
  280 T2=B(J)*B(L)*T2*.25
      GO TO 285
C     ***** TYPES 8 AND 9 (U(I,J) TENSOR SYSTEMS) *****
  281 T2=B(J)*B(L)
      IF(K-11)   285,282,282
C     ***** TYPE 10, (CARTESIAN TENSOR SYSTEM) *****
  282 T2=1.0
  285 IF(J-L)290,287,290
  287 VT(J,J)=T2*PA(J,1,I)
      GO TO 300
  290 M=J+L+1
      VT(J,L)=T2*PA(M,1,I)
      VT(L,J)=VT(J,L)
  300 CONTINUE
C     ***** FIND PRINCIPAL AXES *****
      IF(K-11)   310,305,305
  305 CALL MM(VT,Q,PAC)
      CALL MM(REFV,PAC,VT)
  310 CALL MM(VT,AA,DA)
      CALL EIGEN(DA,RMS,PAT)
C     ***** ARE EIGENVALUES POSITIVE *****
      IF(RMS(1))325,325,320
  320 IF(NG)350,360,330
  325 NG=3
  330 NG1=1
      CALL ERPNT(FLOAT(I)*100000.+55501.,0)
C     ***** 3 EQUAL EIGENVALUES, USE REFERENCE VECTORS *****
  340 T3=SIGN(SQRT(ABS(RMS(1)+RMS(2)+RMS(3))/3.),RMS(1))
      DO 345 J=1,3
      DO 342 K=1,3
  342 PA(J,K,I)=REFV(J,K)
  345 EV(J,I)=T3
      GO TO 450
  350 IF(NG+6)340,340,352
C     ***** TWO EQUAL EIGENVALUES *****
  352 N=NG+5
      CALL UNIT(PAT(1,N),V1,-1)
      DO 354 K=1,3
      IF(ABS(VMV(V1,AA,REFV(1,K)))-.58)356,354,354
  354 CONTINUE
  356 CALL MM(AA,DA,VT)
      CALL AXES(V1,REFV(1,K),DA,-1)
      DO 359 K=1,3
      L=MOD(N+K-2,3)+1
      DO 358 J=1,3
  358 PA(J,L,I)=DA(J,K)
  359 EV(L,I)=SIGN(SQRT(ABS(VMV(DA(1,K),VT,DA(1,K)))),RMS(L))
      GO TO 450
C     ***** MAKE EIGENVECTORS 1 ANGSTROM LONG *****
  360 CALL AXES(PAT(1,1),PAT(1,3),PA(1,1,I),-1)
  370 NG=0
C     ***** SQRT EIGENVALUE = RMS DISPLACEMENT *****
      DO 375 J=1,3
      T2=RMS(J)
  375 EV(J,I)=SIGN(SQRT(ABS(T2)),T2)
      GO TO 450
C     ***** TYPE 6 (ISOTROPIC TEMP FACTOR) *****
  400 T1=SQRT(T1*.012665148)
C     ***** TYPE 7 (DUMMY SPHERE) *****
  405 DO 410 J=1,3
  410 EV(J,I)=T1
      IF(PA(3,1,I))430,430,415
C     ***** DEFINED VECTORS FOR SPHERE *****
  415 DO 425 J=1,4
      T2=PA(J+2,1,I)
      CALL ATOM(T2,VT(1,J))
      IF(NG)420,425,420
  420 CALL ERPNT(T2,0)
      GO TO 430
  425 CONTINUE
      CALL DIFV(VT(1,2),VT(1,1),V1)
      CALL DIFV(VT(1,4),VT(1,3),V2)
      CALL AXES(V1,V2,PA(1,1,I),-1)
      GO TO 450
C     ***** REFERENCE VECTORS FOR SPHERE *****
  430 DO 435 J=1,9
  435 PA(J,1,I)=REFV(J,1)
  450 NG=0
C     ***** WRITE OUT RMS VALUES *****
      LINES=LINES+2
      IF(LINES-56)458,458,455
  455 LINES=-1
      GO TO 460
  458 WRITE (NOUT,461)
  460 DO 465 I=1,NATOM
      LINES=MOD(LINES+1,56)
      IF(LINES)465,462,465
  461 FORMAT(10H0NO. ATOM ,8X,1HX,10X,1HY,10X,1HZ,13X,7HRMSD 1 ,4X,7HRMS
     &D 2 ,4X,7HRMSD 3 )
  462 WRITE (NOUT,177)(TITLE(J),J=1,18)
      WRITE (NOUT,461)
  463 FORMAT(1H ,I3,1X,A6,3F11.6)
  465 WRITE (NOUT,209)I,CHEM(I),(P(J,I),J=1,3),(EV(J,I),J=1,3
     1)
      IF(NG1)999,999,470
  470 stop
  999 RETURN
      END
